
/*****************************************************************************
		Copyright (c) ABORD

 Project:  WXGOTO
 FileName: wxpartie.inc
 Purpose: Module pour la generation des parties
 Written by: L.-O. Pochon
 Comments:
******************************************************************************/

PREDICATES
  make_titre(SYMBOL,INTEGER,INTEGER,STRING,STRING)
  make_position(SYMBOL,INTEGER,INTEGER,INTEGER,STRING,STRING,STRING)

  affiche_navi(SYMBOL,INTEGER,INTEGER,INTEGER,STRING)
  affiche_liste_zones(SYMBOL,INTEGER,INTEGER,STRING,INTEGER,STRING)
  affiche_script(SYMBOL,INTEGER,INTEGER,INTEGER salle,STRING,INTEGER,STRING)
  affiche_body(SYMBOL,INTEGER,INTEGER,STRING,INTEGER,STRING)
  affiche_liste_domaines_haut(SYMBOL,INTEGER,INTEGER,STRING,INTEGER,STRING)
  affiche_liste_domaines_bas(SYMBOL,INTEGER,INTEGER,STRING,INTEGER,STRING)
  affiche_liste_direction(STRING dir,SYMBOL,INTEGER,INTEGER,STRING,INTEGER,STRING)
  affiche_liste_salles(SYMBOL,INTEGER,INTEGER,STRING,INTEGER,STRING)
  marque_eloignement(SYMBOL,INTEGER,INTEGER,STRING,INTEGER eloi,STRING fichier)
  marque_etage(SYMBOL,INTEGER,INTEGER,STRING,INTEGER,STRING fichier)
  affiche_style(SYMBOL,INTEGER,INTEGER)
  choix_image(SYMBOL,INTEGER,INTEGER,STRING orien,INTEGER lev,STRING image_centre_g,STRING image_centre_d,STRING img_droite)
  choix_frise(SYMBOL,INTEGER,INTEGER,STRING orien,INTEGER lev,STRING img,STRING color)
  choix_direc(SYMBOL,INTEGER,INTEGER,STRING orien,INTEGER lev,STRING,STRING,STRING,STRING)
  choix_coule_ve(SYMBOL,INTEGER,INTEGER,STRING orien,INTEGER lev,STRING fond_domaine)
  choix_coule_ba(SYMBOL,INTEGER,INTEGER,STRING orien,INTEGER lev,STRING fond_partie)
  choix_coule_ha(SYMBOL,INTEGER,INTEGER,STRING orien,INTEGER lev,STRING fond_zon_salle)

  make_background(STRING path,STRING img,STRING back)

  hay_salida(STRING,INTEGER,INTEGER,INTEGER,STRING)
  hay_domaine(STRING,INTEGER,STRING sob)
  hay_sdomaine(STRING,INTEGER,INTEGER,STRING)
  hay_sujet(STRING,INTEGER,INTEGER,INTEGER,STRING)
  hay_sujet_open(STRING,INTEGER,INTEGER,INTEGER,STRING) % LOP0903
  hay_sujet_open_sdom0(STRING,INTEGER,INTEGER,INTEGER,STRING) % LOP0903
  hay_activite(STRING,INTEGER,INTEGER,INTEGER,INTEGER)

  control_restriction_salle(STRING,INTEGER,INTEGER,INTEGER,STRING)
  control_restriction_zone(STRING,INTEGER,INTEGER,STRING)

CLAUSES
  send_page_partie(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
	entete_http(),
	make_titre(LIEU,DOM,SDOM,ORIEN,TITLE),
	begin_entete(TITLE),
	
	write("<SCRIPT LANGUAGE=\"JavaScript\">\n"),
	affiche_script(LIEU,DOM,SDOM,-1,ORIEN,LEVEL,SOBRIQUET),
	write("</SCRIPT>\n"),
	
	affiche_style(LIEU,DOM,SDOM),
	
	write("</HEAD>\n"),
	write("<BODY>\n"), %onLoad=\"synchrVariables(document.forms[0])\">\n"),

	affiche_body(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),

	write("</BODY>\n</HTML>").

CLAUSES
 affiche_liste_direction(DIR,CADRE,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
%	write("<P>Parties adjacentes</P>"),
% gnration & test
	path_img(PIMG),
	cadre(CADRE1,_,TITRE,_),
	CADRE1 <> CADRE,
	hay_domaine(CADRE1,LEVEL,SOBRIQUET),
	cadre(ETIQ,_,_,_),
	deplacement_partie(CADRE,DOM,SDOM,ORIEN,ETIQ,CADRE1,DOM1,SDOM1,ORIEN1,DIR,LOIN,MODE),
	LOIN<2,
	make_link("partie",CADRE1,DOM1,SDOM1,-1,ORIEN1,TITRE,ETIQ,DIR,LOIN,LEVEL,SOBRIQUET,MODE,LEVEL,LINK),
	marque_eloignement(CADRE,DOM,SDOM,DIR,1,MARQ),
	writef("<IMG SRC='%/%'>&nbsp;<SPAN CLASS=\"text-dir\">%</SPAN><BR>\n",PIMG,MARQ,LINK),
%	write("<SPAN CLASS=\"text-dir\">",LINK,"</SPAN><BR>\n"),
	fail.
 affiche_liste_direction(DIR,CADRE,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
%	write("<P>Parties eloignees</P>"),
% gnration & test
  	path_img(PIMG),
	cadre(CADRE1,_,TITRE,_),
	cadre(CADRE2,_,_,_),
	CADRE2 <> CADRE,
	hay_domaine(CADRE1,LEVEL,SOBRIQUET),
	deplacement_partie(CADRE,DOM,SDOM,ORIEN,CADRE1,CADRE2,DOM1,SDOM1,ORIEN1,DIR,LOIN,MODE),
	LOIN>=2,
	make_link("partie",CADRE2,DOM1,SDOM1,-1,ORIEN1,TITRE,CADRE1,DIR,LOIN,LEVEL,SOBRIQUET,MODE,LEVEL,LINK),
	marque_eloignement(CADRE,DOM,SDOM,DIR,2,MARQ),
	writef("<IMG SRC='%/%'>&nbsp;<SPAN CLASS=\"text-dir\">%</SPAN><BR>\n",PIMG,MARQ,LINK),
	fail.
 affiche_liste_direction(_,_,_,_,_,_,_).

 affiche_liste_domaines_haut(CADRE,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
%	write("<P>deplacement dans d'autres domaines</P>"),
% gnration & test
% on ne peut changer en mme temps de CADRE 
	get_domaine(CADRE,LEVEL,_NOM,TITRE,DOM1,LEV1), % floor
	DOM1>DOM,
	deplacement_domaine(CADRE,DOM,SDOM,ORIEN,ETIQ,DOM1,SDOM1,ORIEN1,DIR,LOIN,MODE),
	marque_etage(CADRE,DOM1,SDOM,ORIEN,LEV1,MARQ),
	make_link("partie",CADRE,DOM1,SDOM1,-1,ORIEN1,TITRE,ETIQ,DIR,LOIN,LEVEL,SOBRIQUET,MODE,LEV1,LINK),
	writef("<SPAN CLASS=\"text-dom\">% %</SPAN><BR>\n",MARQ,LINK),
	fail.
 affiche_liste_domaines_haut(_,_,_,_,_,_).  

 affiche_liste_domaines_bas(CADRE,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
%	write("<P>deplacement dans d'autres domaines</P>"),
% gnration & test
% on ne peut changer en mme temps de CADRE 
	get_domaine(CADRE,LEVEL,_NOM,TITRE,DOM1,LEV1), % floor
	DOM1<DOM,
	deplacement_domaine(CADRE,DOM,SDOM,ORIEN,ETIQ,DOM1,SDOM1,ORIEN1,DIR,LOIN,MODE),
	marque_etage(CADRE,DOM1,SDOM,ORIEN,LEV1,MARQ),
	make_link("partie",CADRE,DOM1,SDOM1,-1,ORIEN1,TITRE,ETIQ,DIR,LOIN,LEVEL,SOBRIQUET,MODE,LEV1,LINK),
	writef("<SPAN CLASS=\"text-dom\">% %</SPAN><BR>\n",MARQ,LINK),
	fail.
  affiche_liste_domaines_bas(_,_,_,_,_,_).


 affiche_liste_zones(CADRE,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
%	write("</P>Zones<P>"),
% gnration & test
% on ne peut changer en mme temps de CADRE et de DOM (voir exceptions
	get_sdomaine(CADRE,DOM,LEVEL,_NOM,TITRE,SDOM1,LEV1), % floor
	SDOM1<>SDOM,
	control_restriction_zone(CADRE,DOM,SDOM1,SOBRIQUET), %LOP0304
	hay_sujet_open_sdom0(CADRE,DOM,SDOM1,LEVEL,SOBRIQUET), % LOP0903

	deplacement_sdomaine(CADRE,DOM,SDOM,ORIEN,ETIQ,SDOM1,ORIEN1,DIR,LOIN,MODE),
	make_link("partie",CADRE,DOM,SDOM1,-1,ORIEN1,TITRE,ETIQ,DIR,LOIN,LEVEL,SOBRIQUET,MODE,LEV1,LINK),
	write("<SPAN CLASS=\"text-partie\">",LINK,"</SPAN><BR>\n"),
	fail.
 affiche_liste_zones(CADRE,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
	% deplacement exceptionnel zone d'autre partie (LOIN <= 1)
	deplacement_exceptions(CADRE,DOM,SDOM,LEVEL,ORIEN,ETIQ,CADRE1,DOM1,SDOM1,ORIEN1,DIR,LOIN,MODE),
	make_link("partie",CADRE1,DOM1,SDOM1,-1,ORIEN1,ETIQ,ETIQ,DIR,LOIN,LEVEL,SOBRIQUET,MODE,LEVEL,LINK),
	write("<SPAN CLASS=\"text-partie\">",LINK,"</SPAN><BR>\n"),
	fail.
 affiche_liste_zones(_,_,_,_,_,_).

 affiche_liste_salles(CADRE,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
%	write("<P>Salles</P>"),
% gnration & test
	get_sujet(CADRE,DOM,SDOM,LEVEL,_NOM,TITRE,CODE,LEV1),
	existsortie(CADRE,DOM,SDOM,CODE),
	control_restriction_salle(CADRE,DOM,SDOM,CODE,SOBRIQUET), %LOP0304
	hay_activite(CADRE,DOM,SDOM,CODE,LEVEL),
	make_link("salle",CADRE,DOM,SDOM,CODE,ORIEN,TITRE,"","",1,LEVEL,SOBRIQUET,"porte",LEV1,LINK),
	write("<SPAN CLASS=\"text-partie\">",LINK,"</SPAN><BR>\n"),
	fail.
  affiche_liste_salles(_,_,_,_,_,_).  


% selon base de donne de deplacement
  affiche_navi(CADRE,_,_,_,_) :-
        prohiberPart(CADRE),!.
  affiche_navi(CADRE,DOM,_,_,_) :-
        prohiberZone(CADRE,DOM,_),!.
  affiche_navi("hall",0,_,LEV,SOB) :-
        path_scripts(SCRI),
        path_server(PATH),!,
        format(URL,"%?sobriquet=%&level=%&dep=telep",wxgotoexe,SOB,LEV),
        % ajouter language= ...
        writef("<SPAN CLASS='text-partie'><A HREF=\"javascript:parent.ouvreLucarne('%/plan.htm',760,530)\" ONMOUSEOVER=\"hide_status('plan'); return true;\">Plan</A></SPAN><BR>\n",PATH),
	writef("<SPAN CLASS='text-partie'><A HREF=\"javascript:parent.ouvreLucarne('%/guichet.htm',600,400)\" ONMOUSEOVER=\"hide_status('guichet'); return true;\">Guichet d'information</A></SPAN><BR>\n",PATH),
        writef("<SPAN CLASS='text-partie'><A HREF=\"%/accueil.htm\" ONMOUSEOVER=\"hide_status('accueil'); return true;\">R&eacute;ception</A></SPAN><BR>\n",PATH),
        writef("<SPAN CLASS='text-partie'><A HREF=\"%/cafet.htm\" ONMOUSEOVER=\"hide_status('cafet'); return true;\">Cafeteria</A></SPAN><BR>\n",PATH),
        writef("<SPAN CLASS='text-partie'><A HREF=\"%/prive.htm\" ONMOUSEOVER=\"hide_status('prive'); return true;\">Bureau du conservateur</A></SPAN><BR>\n",PATH),
        writef("<SPAN CLASS='text-partie'><A HREF=\"%/%\" ONMOUSEOVER=\"hide_status('telep'); return true;\">T&eacute;l&eacute;porteur</A></SPAN><BR>\n",SCRI,URL).
  affiche_navi(_,_,_,_,_).


  affiche_body(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET) :-
  	path_img(PIMG),!,
  	choix_image(LIEU,DOM,SDOM,ORIEN,LEVEL,IMGC1,IMGC2,IMGD),
  	choix_frise(LIEU,DOM,SDOM,ORIEN,LEVEL,FRISE,_COLOR),
  	choix_direc(LIEU,DOM,SDOM,ORIEN,LEVEL,OUEST,NORD,SUD,EST),
  	choix_coule_ve(LIEU,DOM,SDOM,ORIEN,LEVEL,CZONE),
  	choix_coule_ba(LIEU,DOM,SDOM,ORIEN,LEVEL,CDOM),
  	choix_coule_ha(LIEU,DOM,SDOM,ORIEN,LEVEL,CFOND),
	make_position(LIEU,DOM,SDOM,LEVEL,SOBRIQUET,ETAGE,SPOS),
	
	make_background(PIMG,IMGC1,BCK1),
	make_background(PIMG,IMGC2,BCK2),
	
	write("<CENTER><TABLE WIDTH=\"760\" CELLSPACING=\"0\" BORDER=\"0\">\n"),

% 1ere ligne
	write("<TR ALIGN=\"left\"><TD HEIGHT=\"30\" WIDTH=\"32\" BGCOLOR=\"#666666\">&nbsp;</TD>"),
	writef("<TD WIDTH=\"109\" HEIGHT=\"30\" BGCOLOR=\"%\"><SPAN CLASS=\"text-dom-haut\">%</SPAN></TD>\n",CDOM,ETAGE),
	writef("<TD COLSPAN=\"5\" HEIGHT=\"30\" WIDTH=\"619\" BGCOLOR=\"#666666\"><SPAN CLASS=\"text-haut\">%</SPAN></TD></TR>\n",SPOS),

% 2e ligne
	writef("<TR ALIGN=\"left\"><TD WIDTH=\"32\" HEIGHT=\"370\" ROWSPAN=\"2\" BACKGROUND=\"%/%\">&nbsp;</TD><TD WIDTH=\"109\" HEIGHT=\"370\" BGCOLOR=\"%\" ROWSPAN=\"2\" VALIGN=\"top\"><P>",PIMG,IMGD,CZONE),
	affiche_liste_domaines_haut(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),
	write("\n</P><P>\n"),
	affiche_liste_domaines_bas(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),

	writef("&nbsp;</P>\n</TD><TD WIDTH=\"218\" HEIGHT=\"195\" VALIGN=\"top\" COLSPAN=\"2\" BGCOLOR=\"%\"%>\n",CFOND,BCK1),
	affiche_navi(LIEU,DOM,SDOM,LEVEL,SOBRIQUET),
	affiche_liste_zones(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),

	writef("&nbsp;</TD><TD WIDTH=\"218\" HEIGHT=\"195\" COLSPAN=\"2\" VALIGN=\"top\" BGCOLOR=\"%\"%>\n",CFOND,BCK2),
	affiche_liste_salles(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),
	writef("&nbsp;</TD><TD WIDTH=\"183\" HEIGHT=\"370\" ROWSPAN=\"2\" BACKGROUND=\"%/%\">&nbsp;</TD></TR>\n",PIMG,IMGD),

% 3e ligne
%	write("<TR ALIGN=\"left\"><TD WIDTH=\"125\" BGCOLOR=\"#FF0000\">&nbsp;</TD>\n"),

	writef("<TR ALIGN=\"left\"><TD WIDTH=\"109\" HEIGHT=\"175\" BGCOLOR=\"%\" VALIGN=\"top\"><IMG SRC='%/%'><BR>\n",CDOM,PIMG,OUEST),
	affiche_liste_direction("W",LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),nl,
	writef("</TD><TD WIDTH=\"109\" HEIGHT=\"175\" BGCOLOR=\"%\" VALIGN=\"top\"><IMG SRC='%/%'><BR>\n",CDOM,PIMG,NORD),	
	affiche_liste_direction("N",LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),nl,
	writef("</TD><TD WIDTH=\"109\" HEIGHT=\"175\" BGCOLOR=\"%\" VALIGN=\"top\"><IMG SRC='%/%'><BR>\n",CDOM,PIMG,SUD),	
	affiche_liste_direction("S",LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),nl,
	writef("</TD><TD WIDTH=\"109\" HEIGHT=\"175\" BGCOLOR=\"%\" VALIGN=\"top\"><IMG SRC='%/%'><BR>\n",CDOM,PIMG,EST),	
	affiche_liste_direction("E",LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),nl,
	write("</TD></TR>\n"),	
/*
% 4e ligne
	write("<TR><TD WIDTH=\"760\" BGCOLOR=\"#FF0000\">&nbsp;</TD><TD WIDTH=\"250\" COLSPAN=\"2\" VALIGN=\"top\">"),
	affiche_liste_zones(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),
	write("</TD><TD WIDTH=\"250\" COLSPAN=\"2\" VALIGN=\"top\">"),
	affiche_liste_salles(LIEU,DOM,SDOM,ORIEN,LEVEL,SOBRIQUET),
	write("</TD></TR>"),
*/
% 4e ligne
	writef("<TR><TD WIDTH=\"760\" HEIGHT=\"20\" COLSPAN=\"7\" BACKGROUND=\"%/%\">&nbsp;</TD></TR>\n",PIMG,FRISE),	
%	affiche_fin_navi(LIEU1),
	write("</TABLE></CENTER>\n").

% *************

  make_background(_,"","") :- !.
  make_background(PIMG,IMG,BCK) :-
  	format(BCK," BACKGROUND=\"%/%\"",PIMG,IMG).

PREDICATES
  lev_str(INTEGER,STRING)

CLAUSES
  make_titre(CADRE,DOM,SDOM,ORIEN,TITRE) :-
  	format(TITRE,"%/%/%/%",CADRE,DOM,SDOM,ORIEN).
 
  make_position(CADRE,DOM,SDOM,LEV,SOB,ETAGE,SPOS) :-
	cadre(CADRE,_,TCADRE,_),
	get_domaine1(CADRE,LEV,_,ETAGE1,DOM,_),
    	get_sdomaine1(CADRE,DOM,LEV,_,TSDOM,SDOM,_),!,
    	lev_str(LEV,SLEV),
    	format(ETAGE,"%: %",DOM,ETAGE1),
	format(SPOS,"% - % ** % (%)",TCADRE,TSDOM,SOB,SLEV).

% Note LOP0903 en cas de non existence de label pour le nouveau
% il faudrait toujours un defaut pour le level 0 

  make_position(CADRE,DOM,SDOM,_LEV,SOB,"&nbsp;",SPOS) :-
	make_titre(CADRE,DOM,SDOM,SOB,SPOS).

  lev_str(0,"Visiteur") :- !.
  lev_str(1,"Cours pr&eacute;paratoire") :- !.
  lev_str(2,"Cours &eacute;l&eacute;mentaire") :- !.
  lev_str(3,"Cours moyen") :- !.
  lev_str(4,"Secondaire (6-7)") :- !.
  lev_str(5,"Secondaire (8-9)") :- !.
  lev_str(6,"Lyc&eacute;e") :- !.
  lev_str(7,"Sp&eacute;cialiste") :- !.
  lev_str(8,"Didacticien") :- !.
  lev_str(9,"Administrateur") :- !.
  lev_str(10,"su").

  affiche_script(LIEU,DOM,SDOM,SALLE,ORIEN,_LEVEL,_SOBRIQUET) :-
	format(VAR1,"parent.wxPartie    = \"%\" ;\n",LIEU),
	format(VAR2,"parent.wxFloor     = % ;\n",DOM),
	format(VAR3,"parent.wxZone      = % ;\n",SDOM),
	format(VAR4 ,"parent.wxSalle    = % ;\n",SALLE),
	VAR5 = "parent.wxCurrentUi = \"\" ;\n",
	format(VAR6,"parent.wxDir       = \"%\" ;\n",ORIEN),
	write(VAR1,VAR2,VAR3,VAR4,VAR5,VAR6),nl,
	write("function hide_status(msg) {\n  return parent.hide_status(msg) ;\n}\n").

PREDICATES
  aile(STRING,STRING)
  couleur_zone_texte(SYMBOL,INTEGER,INTEGER,STRING)
  mef_mod1(INTEGER,INTEGER,STRING)
  
/*
Les couleurs des textes sont donn par le nom des styles ?
  choix_couleur(SYMBOL lieu,INTEGER dom,INTEGER sdom,
                STRING coul_colonne_fond, % domaine
                STRING coul_colonne_texte,
                STRING coul_colonne_texte_lien,
                STRING coul_colonne_fond_haut
                STRING coul_colonne_texte_haut,

                STRING coul_haut_fond,
                STRING coul_haut_texte,

                STRING coul_zone_fond, % zone et salle
                STRING coul_zone_texte,
                STRING coul_zone_texte_lien,

                STRING coul_direction_fond, % partie
                STRING coul_direction_texte,
                STRING coul_direction_texte_lien) */

CLAUSES

% image zone centrale suprieure (en deux parties) et zone de droite
%  changer aussi couleur_zone_texte qui est la couleur dans la zone centrale suprieures
% dans le futur la zone de droite sera remplie par un appel a un script fournissant
% un lment graphique ou textuel !

% pavage_01_pos.gif pavage_01_neg.gif
% pavage_14_pos.gif pavage_14_neg.gif
% les gris tess11, 12, 12b, 22b c d

% choix_image(partie,etage,zone,orien, niveau,img-g,img-d,img-v)

  choix_image("hall",_,1,_,_,"pavages/tess22b.gif","pavages/tess22b.gif","porte_2.gif") :- !. % ascenseur
  choix_image("hall",0,2,_,_,"pavages/tess22c.gif","pavages/tess22c.gif","porte_1.gif") :- !. % concours trimestriel
  choix_image("hall",2,2,_,_,"pavages/tess22d.gif","pavages/tess22d.gif","fsc.gif") :- !. % science et cit
  choix_image("hall",_,2,_,_,"pavages/tess22d.gif","pavages/tess22d.gif","porte_1.gif") :- !. % expo_temporaire

  choix_image("hall",0,_,_,_,"fond_hall_centre1.jpg","fond_hall_centre2.jpg","fond_hall_droite.jpg") :- !.
  choix_image("hall",DOM,_,_,_,"","",HALL) :- !,
  	NO= 1 + DOM mod 5,
  	format(HALL,"hall_%.gif",NO).
 
/*  choix_image("ense",DOM,SDOM,_RIEN,_EVEL,"pavages/tess12.gif","pavages/tess12.gif",SPECIAL) :-
	existsortie("ense",DOM,SDOM,_),!, % si il y a une salle
  	NO= (DOM+SDOM) mod 6,
  	format(SPECIAL,"special_%.gif",NO).
*/ 
  choix_image(LIEU,DOM,SDOM,_RIEN,_EVEL,MUR,MUR,SPECIAL) :-
	existsortie(LIEU,DOM,SDOM,_), % si il y a une salle
	aile(LIEU,"a"),!,
	SDOM_DOM = SDOM+DOM,
	mef_mod1(SDOM_DOM,14,NO1),
	format(MUR,"pavages/pavage_%_pos.gif",NO1),
  	NO= SDOM_DOM mod 6,
  	format(SPECIAL,"special_%.gif",NO).

  choix_image(LIEU,DOM,SDOM,_RIEN,_EVEL,MUR,MUR,SPECIAL) :-
	existsortie(LIEU,DOM,SDOM,_), % si il y a une salle
	aile(LIEU,"b"),!,
	SDOM_DOM = SDOM+DOM,
	mef_mod1(SDOM_DOM,14,NO1),
	format(MUR,"pavages/pavage_%_neg.gif",NO1),
  	NO= SDOM_DOM mod 6,
  	format(SPECIAL,"special_%.gif",NO).
  	
  choix_image("hist",_DOM,0,_RIEN,_EVEL,"pavages/tess11.gif","pavages/tess11.gif","escalier_3a.gif") :-!.
%	il y a un escalier dans le SDOM 0
  choix_image("dida",_DOM,0,_RIEN,_EVEL,"pavages/tess12.gif","pavages/tess12.gif","escalier_2a.gif") :-!.
  choix_image("ense",_DOM,0,_RIEN,_EVEL,"pavages/tess12b.gif","pavages/tess12b.gif","escalier_3b.gif") :- !.
  choix_image("theo",_DOM,0,_RIEN,_EVEL,"pavages/tess11b.gif","pavages/tess11b.gif","escalier_2b.gif") :- !.
  choix_image("fict",_DOM,0,_RIEN,_EVEL,"pavages/tess13b.gif","pavages/tess13b.gif","escalier_7a.gif") :- !.
  choix_image("vide",_DOM,0,_RIEN,_EVEL,"","","escalier_7b.gif") :- !.
% ancoenne viersion	 det_altitude("vide",1,1,_,_,_),!. % si il y a un escalier
	 % reste esaclier 1 au bout des jeux ?

% ces couloirs apparaissent-ils ?	 
  choix_image("ense",DOM,_DOM,_RIEN,_EVEL,"pavages/tess14b.gif","pavages/tess14b.gif",IMG_COUL) :- !,
  	NO = 1 + (DOM mod 9),
  	format(IMG_COUL,"couloir_%.gif",NO).	
  choix_image(_IEU,DOM,_DOM,_RIEN,_EVEL,"pavages/tess15b.gif","pavages/tess15b.gif",IMG_COUL) :-
  	NO = 1 + (DOM mod 9),
  	format(IMG_COUL,"couloir_%.gif",NO).	

% choix de la frise
  choix_frise(LIEU,DOM,SDOM,_ORIEN,_LEV,FRISE,"#FFFFFF") :-
  	NO = 1 + ((DOM+SDOM) mod 8),
  	aile(LIEU,LETTRE),
  	format(FRISE1,"pavages/frise_%",NO),
	concat(FRISE1,LETTRE,FRISE2),
	concat(FRISE2,".gif",FRISE).

% choix du marquage des titres de direction (zone centrale basse)
  choix_direc(_LIEU,_DOM,_SDOM,_OR,_LEVEL,"ouest_clair.gif","nord_clair.gif","sud_clair.gif","est_clair.gif") :- !.

% couleur fond de la colonne, bande horizontale, place zone et salle
  choix_coule_ve("hall",_DOM,_SDOM,_OR,_LEVEL,"#CC0000") :- !.
  choix_coule_ve("hist",_DOM,_SDOM,_OR,_LEVEL,"#993333") :- !.
  choix_coule_ve("dida",_DOM,_SDOM,_OR,_LEVEL,"#CC6666") :- !.
  choix_coule_ve("appl",_DOM,_SDOM,_OR,_LEVEL,"#990033") :- !.
  choix_coule_ve("fict",_DOM,_SDOM,_OR,_LEVEL,"#FF0000") :- !.
  choix_coule_ve("jeux",_DOM,_SDOM,_OR,_LEVEL,"#CC0000") :- !.
  choix_coule_ve("ense",_DOM,_SDOM,_OR,_LEVEL,"#993333") :- !.
  choix_coule_ve("theo",_DOM,_SDOM,_OR,_LEVEL,"#CC6666") :- !.
  choix_coule_ve("info",_DOM,_SDOM,_OR,_LEVEL,"#990033") :- !.
  choix_coule_ve("vide",_DOM,_SDOM,_OR,_LEVEL,"#FF0000") :- !.

  choix_coule_ba(_,0,_,_,_,"#CC3333") :- !.
  choix_coule_ba(_,1,_,_,_,"#FF3333") :- !.
  choix_coule_ba(_,2,_,_,_,"#990033") :- !.
  choix_coule_ba(_,3,_,_,_,"#3300CC") :- !.
  choix_coule_ba(_,4,_,_,_,"#FF00FF") :- !.
  choix_coule_ba(_,5,_,_,_,"#3300FF") :- !.
  choix_coule_ba(_,6,_,_,_,"#666633") :- !.
  choix_coule_ba(_,7,_,_,_,"#336600") :- !.
  choix_coule_ba(_,8,_,_,_,"#003333") :- !.
  choix_coule_ba(_,9,_,_,_,"#666666") :- !.
  choix_coule_ha(_,_,_,_,_,"gray") :- !.
 
% symbole pour les ailes (suffixe d'images symtriques)
  aile("hist","a") :- !.
  aile("dida","a") :- !.
  aile("appl","a") :- !.
  aile("fict","a") :- !.
  aile("jeux","a") :- !.
  aile("theo","b") :- !.
  aile("ense","b") :- !.
  aile("info","b") :- !.
  aile("vide","b") :- !.
  aile("hall","b") :- !.
  
  marque_eloignement(_,_,_,"W",2,"2_fleches_g.gif") :- !.
  marque_eloignement(_,_,_,"E",2,"2_fleches_d.gif") :- !.
  marque_eloignement(_,_,_,"N",2,"2_fleches_h.gif") :- !.
  marque_eloignement(_,_,_,"S",2,"2_fleches_b.gif") :- !.
  marque_eloignement(_,_,_,"W",1,"1_fleches_g.gif") :- !.
  marque_eloignement(_,_,_,"E",1,"1_fleches_d.gif") :- !.
  marque_eloignement(_,_,_,"N",1,"1_fleches_h.gif") :- !.
  marque_eloignement(_,_,_,"S",1,"1_fleches_b.gif") :- !.
  
 % marque_etage(_CADRE,DOM1,_SDOM,_ORIEN,_LEV1,MARQ) :- 
 % 	format(MARQ,"%:",DOM1).
  marque_etage(_CADRE,DOM1,_SDOM,_ORIEN,_LEV1,MARQ) :- 
	path_img(PIMG),!,
	format(MARQ,"<IMG SRC='%/etage_%.gif'>",PIMG,DOM1).
	  
  affiche_style(LIEU,DOM,SDOM) :-
  	couleur_zone_texte(LIEU,DOM,SDOM,COUL),
	write("<STYLE TYPE=\"text/css\">\n"),
	write("BODY {background: white;}\n"),
	write("SPAN.text-haut {font-family: arial, helvetica, sans-serif; color: #FFFFFF; }\n"), 
	write("SPAN.text2 {font-family: arial, helvetica, sans-serif; color: #FFCCCC; }\n"),  % titre direction provisoire
	write("SPAN.text-dom-haut {font-family: arial, helvetica, sans-serif; color: #FFCCCC; font-size: small; }\n"),
	write("SPAN.text-dom A {font-family: arial, helvetica, sans-serif; color: #FFCCCC; }\n"),
	write("SPAN.text-dom   {font-family: arial, helvetica, sans-serif; color: black; }\n"),
	write("SPAN.text-dir A {font-family: arial, helvetica, sans-serif; color: white; }\n"),
	writef("SPAN.text-partie A {font-family: arial, helvetica, sans-serif; color: %; }\n",COUL),
%	write("A {color: white; font-family: arial, helvetica, sans-serif;}"),
	write("</STYLE>\n").

  couleur_zone_texte("hall",0,0,"red") :- !.
  couleur_zone_texte("hall",0,2,"red") :- !.
  couleur_zone_texte("hall",2,2,"red") :- !.
  couleur_zone_texte("ense",_,_,"black") :- !.
  couleur_zone_texte(_,_,_,"blue").

% sort une chaine de 2 caracteres correspondant  1+(X mod M)
  mef_mod1(X,M,RES) :- 
  	R = 1 + (X mod M),
  	R>=10,!,
  	str_int(RES,R).

  mef_mod1(X,M,RES) :- 
  	R = 1 + (X mod M),
  	format(RES,"0%",R).

% pour toujours afficher le palier
  hay_sujet_open_sdom0(_CADRE,_DOM,0,_LEVEL,_SOB):- !. % LOP0903
  hay_sujet_open_sdom0(CADRE,DOM,SDOM1,LEVEL,SOB) :-
	hay_sujet_open(CADRE,DOM,SDOM1,LEVEL,SOB).
